% Auto-generated by cameraCalibrator app on 24-Oct-2020
%-------------------------------------------------------


% Define images to process
imageFileNames = {'pattern_calibration\1.jpg',...
    'pattern_calibration\2.jpg',...
    'pattern_calibration\3.jpg',...
    'pattern_calibration\4.jpg',...
    'pattern_calibration\5.jpg',...
    'pattern_calibration\7.jpg',...
    'pattern_calibration\8.jpg',...
    'pattern_calibration\9.jpg',...
    'pattern_calibration\10.jpg',...
    'pattern_calibration\11.jpg',...
    'pattern_calibration\12.jpg',...
    'pattern_calibration\13.jpg',...
    'pattern_calibration\14.jpg',...
    'pattern_calibration\15.jpg',...
    'pattern_calibration\16.jpg',...
    'pattern_calibration\17.jpg',...
    'pattern_calibration\18.jpg',...
    'pattern_calibration\19.jpg',...
    'pattern_calibration\20.jpg',...
    'pattern_calibration\21.jpg',...
    'pattern_calibration\22.jpg',...
    'pattern_calibration\23.jpg',...
    'pattern_calibration\24.jpg',...
    'pattern_calibration\25.jpg',...
    'pattern_calibration\26.jpg',...
    'pattern_calibration\27.jpg',...
    'pattern_calibration\28.jpg',...
    'pattern_calibration\29.jpg',...
    'pattern_calibration\30.jpg',...
    'pattern_calibration\33.jpg',...
    'pattern_calibration\34.jpg',...
    'pattern_calibration\35.jpg',...
    'pattern_calibration\36.jpg',...
    'pattern_calibration\37.jpg',...
    'pattern_calibration\38.jpg',...
    'pattern_calibration\39.jpg',...
    'pattern_calibration\40.jpg',...
    'pattern_calibration\41.jpg',...
    'pattern_calibration\42.jpg',...
    'pattern_calibration\43.jpg',...
    'pattern_calibration\44.jpg',...
    'pattern_calibration\45.jpg',...
    'pattern_calibration\46.jpg',...
    'pattern_calibration\47.jpg',...
    'pattern_calibration\48.jpg',...
    'pattern_calibration\49.jpg',...
    'pattern_calibration\50.jpg',...
    'pattern_calibration\51.jpg',...
    'pattern_calibration\52.jpg',...
    'pattern_calibration\53.jpg',...
    'pattern_calibration\54.jpg',...
    'pattern_calibration\55.jpg',...
    'pattern_calibration\56.jpg',...
    'pattern_calibration\57.jpg',...
    'pattern_calibration\58.jpg',...
    'pattern_calibration\59.jpg',...
    'pattern_calibration\60.jpg',...
    };
% Detect checkerboards in images
[imagePoints, boardSize, imagesUsed] = detectCheckerboardPoints(imageFileNames);
imageFileNames = imageFileNames(imagesUsed);

% Read the first image to obtain image size
originalImage = imread(imageFileNames{1});
[mrows, ncols, ~] = size(originalImage);

% Generate world coordinates of the corners of the squares
squareSize = 4.487000e+01;  % in units of 'millimeters'
worldPoints = generateCheckerboardPoints(boardSize, squareSize);

% Calibrate the camera
[cameraParams, imagesUsed, estimationErrors] = estimateCameraParameters(imagePoints, worldPoints, ...
    'EstimateSkew', false, 'EstimateTangentialDistortion', false, ...
    'NumRadialDistortionCoefficients', 2, 'WorldUnits', 'millimeters', ...
    'InitialIntrinsicMatrix', [], 'InitialRadialDistortion', [], ...
    'ImageSize', [mrows, ncols]);

% View reprojection errors
h1=figure; showReprojectionErrors(cameraParams);

% Visualize pattern locations
h2=figure; showExtrinsics(cameraParams, 'PatternCentric');

% Display parameter estimation errors
displayErrors(estimationErrors, cameraParams);

% See additional examples of how to use the calibration data.  At the prompt type:
% showdemo('MeasuringPlanarObjectsExample')
% showdemo('StructureFromMotionExample')
